Package org.zkoss.stateless.sul

## Interface IRadio

- All Superinterfaces:
    `IAnyGroup<IRadio>`, `ICheckboxBase<IRadio>`, `IChildrenOfInputgroup<IRadio>`, `IComponent<IRadio>`, `IHtmlBasedComponent<IRadio>`, `ILabelElement<IRadio>`, `ILabelImageElement<IRadio>`, `IXulElement<IRadio>`

      public interface IRadio
      extends ICheckboxBase<IRadio>, IAnyGroup<IRadio>

  Immutable `Radio` component

  A radio button.

  Radio buttons without a ancestor `IRadiogroup` is considered as the same group. The nearest ancestor `IRadiogroup` is the group that the radio belongs to.

  ### Support @Action

  Name | Action Type
  --- | ---
  onCheck | ActionData: `CheckData` Denotes when a component is checked or unchecked.
  onFocus | Denotes when a component gets the focus. Remember event listeners execute at the server, so the focus at the client might be changed when the event listener for `onFocus` got executed.
  onBlur | Denotes when a component loses the focus. Remember event listeners execute at the server, so the focus at the client might be changed when the event listener for `onBlur` got executed.

  Author:
    katherine
  See Also:
    `Radio`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IRadio.Builder` | Builds instances of type `IRadio`.
    `static class` | `IRadio.Updater` | Builds an updater of type `IRadio` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IRadio` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getRadiogroup()` | Returns the id of the `IRadiogroup` that groups this radio
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default boolean` | `isSelected()` | Returns whether it is selected.
    `static IRadio` | `of​(java.lang.String label)` | Returns the instance with the given label.
    `static IRadio` | `of​(java.lang.String label, java.lang.String image)` | Returns the instance with the given label and image.
    `static IRadio` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IRadio` | `ofImage​(java.lang.String image)` | Returns the instance with the given image.
    `IRadio` | `withRadiogroup​(java.lang.String radiogroupId)` | Returns a copy of `this` immutable component with the specified `radiogroupId`.
    `default IRadio` | `withSelected​(boolean selected)` | Returns a copy of `this` immutable component with the specified `selected`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.ICheckboxBase

      `getAutodisable, getName, getValue, isChecked, isDisabled, isIndeterminate, withAutodisable, withChecked, withDisabled, withIndeterminate, withName, withValue`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelImageElement

      `getHoverImage, getIconSclass, getIconSclasses, getIconTooltip, getIconTooltips, getImage, isPreloadImage, withHoverImage, withIconSclass, withIconSclasses, withIconTooltip, withIconTooltips, withImage, withPreloadImage`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IRadio DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.wgt.Radio"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IRadio>`

    - #### getRadiogroup

          @Nullable
          java.lang.String getRadiogroup()

      Returns the id of the `IRadiogroup` that groups this radio

      Default: `null`

    - #### withRadiogroup

          IRadio withRadiogroup​(@Nullable
                                java.lang.String radiogroupId)

      Returns a copy of `this` immutable component with the specified `radiogroupId`.

      Sets the id of the `IRadiogroup` that groups this radio

      Parameters:
        `radiogroupId` - The id of `IRadiogroup`.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### isSelected

          @Lazy
          default boolean isSelected()

      Returns whether it is selected.

      Default: `false`.

    - #### withSelected

          default IRadio withSelected​(boolean selected)

      Returns a copy of `this` immutable component with the specified `selected`.

      Sets to select the radio or not.

      Parameters:
        `selected` - Whether to select the radio.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IRadio of​(java.lang.String label)

      Returns the instance with the given label.
      Parameters:
        `label` - The label of the component

    - #### of

          static IRadio of​(java.lang.String label,
                           java.lang.String image)

      Returns the instance with the given label and image.
      Parameters:
        `label` - The label of the component
        `image` - The image of the component

    - #### ofImage

          static IRadio ofImage​(java.lang.String image)

      Returns the instance with the given image.
      Parameters:
        `image` - The image of the component

    - #### ofId

          static IRadio ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component